<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>POIFSFileSystem (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="POIFSFileSystem (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":9,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":10,"i18":10,"i19":10,"i20":10,"i21":10,"i22":10,"i23":9,"i24":10,"i25":10,"i26":10,"i27":10,"i28":10};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/POIFSFileSystem.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/poifs/filesystem/POIFSDocumentPath.html"
               title="class in org.apache.poi.poifs.filesystem"><span class="typeNameLink">Prev&nbsp;Class</span></a>
        </li>
        <li><a href="../../../../../org/apache/poi/poifs/filesystem/POIFSMiniStore.html"
               title="class in org.apache.poi.poifs.filesystem"><span class="typeNameLink">Next&nbsp;Class</span></a>
        </li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/poifs/filesystem/POIFSFileSystem.html" target="_top">Frames</a>
        </li>
        <li><a href="POIFSFileSystem.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li><a href="#nested.classes.inherited.from.class.org.apache.poi.poifs.filesystem.BlockStore">Nested</a>&nbsp;|&nbsp;
            </li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.poifs.filesystem</div>
    <h2 title="Class POIFSFileSystem" class="title">Class POIFSFileSystem</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li><a href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html"
                       title="class in org.apache.poi.poifs.filesystem">org.apache.poi.poifs.filesystem.BlockStore</a>
                </li>
                <li>
                    <ul class="inheritance">
                        <li>org.apache.poi.poifs.filesystem.POIFSFileSystem</li>
                    </ul>
                </li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <dl>
                    <dt>All Implemented Interfaces:</dt>
                    <dd>java.io.Closeable, java.lang.AutoCloseable, <a
                            href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html"
                            title="interface in org.apache.poi.poifs.dev">POIFSViewable</a></dd>
                </dl>
                <hr>
                <br>
                <pre>public class <span class="typeNameLabel">POIFSFileSystem</span>
extends <a href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html"
           title="class in org.apache.poi.poifs.filesystem">BlockStore</a>
implements <a href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html"
              title="interface in org.apache.poi.poifs.dev">POIFSViewable</a>, java.io.Closeable</pre>
                <div class="block"><p>This is the main class of the POIFS system; it manages the entire
                    life cycle of the filesystem.</p>
                    <p>This is the new NIO version, which uses less memory</p></div>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- ======== NESTED CLASS SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="nested.class.summary">
                        <!--   -->
                    </a>
                        <h3>Nested Class Summary</h3>
                        <ul class="blockList">
                            <li class="blockList"><a
                                    name="nested.classes.inherited.from.class.org.apache.poi.poifs.filesystem.BlockStore">
                                <!--   -->
                            </a>
                                <h3>Nested classes/interfaces inherited from class&nbsp;org.apache.poi.poifs.filesystem.<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html"
                                        title="class in org.apache.poi.poifs.filesystem">BlockStore</a></h3>
                                <code><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.ChainLoopDetector.html"
                                        title="class in org.apache.poi.poifs.filesystem">BlockStore.ChainLoopDetector</a></code>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ======== CONSTRUCTOR SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.summary">
                        <!--   -->
                    </a>
                        <h3>Constructor Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Constructor Summary table, listing constructors, and an explanation">
                            <caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colOne" scope="col">Constructor and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#POIFSFileSystem--">POIFSFileSystem</a></span>()</code>
                                    <div class="block">Constructor, intended for writing</div>
                                </td>
                            </tr>
                            <tr class="rowColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#POIFSFileSystem-java.io.File-">POIFSFileSystem</a></span>(java.io.File&nbsp;file)</code>
                                    <div class="block">Creates a POIFSFileSystem from a <tt>File</tt>.</div>
                                </td>
                            </tr>
                            <tr class="altColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#POIFSFileSystem-java.io.File-boolean-">POIFSFileSystem</a></span>(java.io.File&nbsp;file,
                                    boolean&nbsp;readOnly)</code>
                                    <div class="block">Creates a POIFSFileSystem from a <tt>File</tt>.</div>
                                </td>
                            </tr>
                            <tr class="rowColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#POIFSFileSystem-java.nio.channels.FileChannel-">POIFSFileSystem</a></span>(java.nio.channels.FileChannel&nbsp;channel)</code>
                                    <div class="block">Creates a POIFSFileSystem from an open <tt>FileChannel</tt>.
                                    </div>
                                </td>
                            </tr>
                            <tr class="altColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#POIFSFileSystem-java.nio.channels.FileChannel-boolean-">POIFSFileSystem</a></span>(java.nio.channels.FileChannel&nbsp;channel,
                                    boolean&nbsp;readOnly)</code>
                                    <div class="block">Creates a POIFSFileSystem from an open <tt>FileChannel</tt>.
                                    </div>
                                </td>
                            </tr>
                            <tr class="rowColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#POIFSFileSystem-java.io.InputStream-">POIFSFileSystem</a></span>(java.io.InputStream&nbsp;stream)</code>
                                    <div class="block">Create a POIFSFileSystem from an <tt>InputStream</tt>.</div>
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t1" class="tableTab"><span><a
                                    href="javascript:show(1);">Static Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#close--">close</a></span>()</code>
                                    <div class="block">Closes the FileSystem, freeing any underlying files, streams
                                        and buffers.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code>static <a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                        title="class in org.apache.poi.poifs.filesystem">POIFSFileSystem</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#create-java.io.File-">create</a></span>(java.io.File&nbsp;file)</code>
                                    <div class="block">Creates a new <a
                                            href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                            title="class in org.apache.poi.poifs.filesystem"><code>POIFSFileSystem</code></a>
                                        in a new <code>File</code>.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i2" class="altColor">
                                <td class="colFirst"><code>protected java.nio.ByteBuffer</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#createBlockIfNeeded-int-">createBlockIfNeeded</a></span>(int&nbsp;offset)</code>
                                    <div class="block">Load the block at the given offset,
                                        extending the file if needed
                                    </div>
                                </td>
                            </tr>
                            <tr id="i3" class="rowColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DirectoryEntry.html"
                                        title="interface in org.apache.poi.poifs.filesystem">DirectoryEntry</a></code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#createDirectory-java.lang.String-">createDirectory</a></span>(java.lang.String&nbsp;name)</code>
                                    <div class="block">create a new DirectoryEntry in the root directory</div>
                                </td>
                            </tr>
                            <tr id="i4" class="altColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DocumentEntry.html"
                                        title="interface in org.apache.poi.poifs.filesystem">DocumentEntry</a></code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#createDocument-java.io.InputStream-java.lang.String-">createDocument</a></span>(java.io.InputStream&nbsp;stream,
                                    java.lang.String&nbsp;name)</code>
                                    <div class="block">Create a new document to be added to the root directory</div>
                                </td>
                            </tr>
                            <tr id="i5" class="rowColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DocumentEntry.html"
                                        title="interface in org.apache.poi.poifs.filesystem">DocumentEntry</a></code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#createDocument-java.lang.String-int-org.apache.poi.poifs.filesystem.POIFSWriterListener-">createDocument</a></span>(java.lang.String&nbsp;name,
                                    int&nbsp;size,
                                    <a href="../../../../../org/apache/poi/poifs/filesystem/POIFSWriterListener.html"
                                       title="interface in org.apache.poi.poifs.filesystem">POIFSWriterListener</a>&nbsp;writer)</code>
                                    <div class="block">create a new DocumentEntry in the root entry; the data will be
                                        provided later
                                    </div>
                                </td>
                            </tr>
                            <tr id="i6" class="altColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DocumentInputStream.html"
                                        title="class in org.apache.poi.poifs.filesystem">DocumentInputStream</a></code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#createDocumentInputStream-java.lang.String-">createDocumentInputStream</a></span>(java.lang.String&nbsp;documentName)</code>
                                    <div class="block">open a document in the root entry's list of entries</div>
                                </td>
                            </tr>
                            <tr id="i7" class="rowColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DocumentEntry.html"
                                        title="interface in org.apache.poi.poifs.filesystem">DocumentEntry</a></code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#createOrUpdateDocument-java.io.InputStream-java.lang.String-">createOrUpdateDocument</a></span>(java.io.InputStream&nbsp;stream,
                                    java.lang.String&nbsp;name)</code>
                                    <div class="block">Set the contents of a document in the root directory,
                                        creating if needed, otherwise updating
                                    </div>
                                </td>
                            </tr>
                            <tr id="i8" class="altColor">
                                <td class="colFirst"><code>protected <a
                                        href="../../../../../org/apache/poi/poifs/storage/BATBlock.BATBlockAndIndex.html"
                                        title="class in org.apache.poi.poifs.storage">BATBlock.BATBlockAndIndex</a></code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#getBATBlockAndIndex-int-">getBATBlockAndIndex</a></span>(int&nbsp;offset)</code>
                                    <div class="block">Returns the BATBlock that handles the specified offset,
                                        and the relative index within it
                                    </div>
                                </td>
                            </tr>
                            <tr id="i9" class="rowColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#getBigBlockSize--">getBigBlockSize</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i10" class="altColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/poifs/common/POIFSBigBlockSize.html"
                                        title="class in org.apache.poi.poifs.common">POIFSBigBlockSize</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#getBigBlockSizeDetails--">getBigBlockSizeDetails</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i11" class="rowColor">
                                <td class="colFirst"><code>protected java.nio.ByteBuffer</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#getBlockAt-int-">getBlockAt</a></span>(int&nbsp;offset)</code>
                                    <div class="block">Load the block at the given offset.</div>
                                </td>
                            </tr>
                            <tr id="i12" class="altColor">
                                <td class="colFirst"><code>protected int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#getBlockStoreBlockSize--">getBlockStoreBlockSize</a></span>()</code>
                                    <div class="block">Returns the size of the blocks managed through the block store.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i13" class="rowColor">
                                <td class="colFirst"><code>protected <a
                                        href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.ChainLoopDetector.html"
                                        title="class in org.apache.poi.poifs.filesystem">BlockStore.ChainLoopDetector</a></code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#getChainLoopDetector--">getChainLoopDetector</a></span>()</code>
                                    <div class="block">Creates a Detector for loops in the chain</div>
                                </td>
                            </tr>
                            <tr id="i14" class="altColor">
                                <td class="colFirst"><code>protected int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#getFreeBlock--">getFreeBlock</a></span>()</code>
                                    <div class="block">Finds a free block, and returns its offset.</div>
                                </td>
                            </tr>
                            <tr id="i15" class="rowColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/poifs/storage/HeaderBlock.html"
                                        title="class in org.apache.poi.poifs.storage">HeaderBlock</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#getHeaderBlock--">getHeaderBlock</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i16" class="altColor">
                                <td class="colFirst"><code>protected int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#getNextBlock-int-">getNextBlock</a></span>(int&nbsp;offset)</code>
                                    <div class="block">Works out what block follows the specified one.</div>
                                </td>
                            </tr>
                            <tr id="i17" class="rowColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/poifs/property/PropertyTable.html"
                                        title="class in org.apache.poi.poifs.property">PropertyTable</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#getPropertyTable--">getPropertyTable</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i18" class="altColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DirectoryNode.html"
                                        title="class in org.apache.poi.poifs.filesystem">DirectoryNode</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#getRoot--">getRoot</a></span>()</code>
                                    <div class="block">Get the root entry</div>
                                </td>
                            </tr>
                            <tr id="i19" class="rowColor">
                                <td class="colFirst"><code>java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#getShortDescription--">getShortDescription</a></span>()</code>
                                    <div class="block">Provides a short description of the object, to be used when a
                                        POIFSViewable object has not provided its contents.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i20" class="altColor">
                                <td class="colFirst"><code>java.lang.Object[]</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#getViewableArray--">getViewableArray</a></span>()</code>
                                    <div class="block">Get an array of objects, some of which may implement
                                        POIFSViewable
                                    </div>
                                </td>
                            </tr>
                            <tr id="i21" class="rowColor">
                                <td class="colFirst"><code>java.util.Iterator&lt;java.lang.Object&gt;</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#getViewableIterator--">getViewableIterator</a></span>()</code>
                                    <div class="block">Get an Iterator of objects, some of which may implement
                                        POIFSViewable
                                    </div>
                                </td>
                            </tr>
                            <tr id="i22" class="altColor">
                                <td class="colFirst"><code>boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#isInPlaceWriteable--">isInPlaceWriteable</a></span>()</code>
                                    <div class="block">Does the filesystem support an in-place write via
                                        <a href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#writeFilesystem--"><code>writeFilesystem()</code></a>
                                        ? If false, only writing out to
                                        a brand new file via <a
                                                href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#writeFilesystem-java.io.OutputStream-"><code>writeFilesystem(OutputStream)</code></a>
                                        is supported.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i23" class="rowColor">
                                <td class="colFirst"><code>static void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#main-java.lang.String:A-">main</a></span>(java.lang.String[]&nbsp;args)</code>
                                    <div class="block">read in a file and write it back out again</div>
                                </td>
                            </tr>
                            <tr id="i24" class="altColor">
                                <td class="colFirst"><code>boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#preferArray--">preferArray</a></span>()</code>
                                    <div class="block">Give viewers a hint as to whether to call getViewableArray or
                                        getViewableIterator
                                    </div>
                                </td>
                            </tr>
                            <tr id="i25" class="rowColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#setNextBlock-int-int-">setNextBlock</a></span>(int&nbsp;offset,
                                    int&nbsp;nextBlock)</code>
                                    <div class="block">Changes the record of what block follows the specified one.</div>
                                </td>
                            </tr>
                            <tr id="i26" class="altColor">
                                <td class="colFirst"><code>protected long</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#size--">size</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i27" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#writeFilesystem--">writeFilesystem</a></span>()</code>
                                    <div class="block">Write the filesystem out to the open file.</div>
                                </td>
                            </tr>
                            <tr id="i28" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#writeFilesystem-java.io.OutputStream-">writeFilesystem</a></span>(java.io.OutputStream&nbsp;stream)</code>
                                    <div class="block">Write the filesystem out</div>
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait,
                                    wait, wait</code></li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ========= CONSTRUCTOR DETAIL ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.detail">
                        <!--   -->
                    </a>
                        <h3>Constructor Detail</h3>
                        <a name="POIFSFileSystem--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>POIFSFileSystem</h4>
                                <pre>public&nbsp;POIFSFileSystem()</pre>
                                <div class="block">Constructor, intended for writing</div>
                            </li>
                        </ul>
                        <a name="POIFSFileSystem-java.io.File-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>POIFSFileSystem</h4>
                                <pre>public&nbsp;POIFSFileSystem(java.io.File&nbsp;file)
                throws java.io.IOException</pre>
                                <div class="block"><p>Creates a POIFSFileSystem from a <tt>File</tt>. This uses less
                                    memory than
                                    creating from an <tt>InputStream</tt>. The File will be opened read-only</p>

                                    <p>Note that with this constructor, you will need to call <a
                                            href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#close--"><code>close()</code></a>
                                        when you're done to have the underlying file closed, as the file is
                                        kept open during normal operation to read the data out.</p></div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>file</code> - the File from which to read the data</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - on errors reading, or on invalid data</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="POIFSFileSystem-java.io.File-boolean-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>POIFSFileSystem</h4>
                                <pre>public&nbsp;POIFSFileSystem(java.io.File&nbsp;file,
                       boolean&nbsp;readOnly)
                throws java.io.IOException</pre>
                                <div class="block"><p>Creates a POIFSFileSystem from a <tt>File</tt>. This uses less
                                    memory than
                                    creating from an <tt>InputStream</tt>.</p>

                                    <p>Note that with this constructor, you will need to call <a
                                            href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#close--"><code>close()</code></a>
                                        when you're done to have the underlying file closed, as the file is
                                        kept open during normal operation to read the data out.</p></div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>file</code> - the File from which to read or read/write the data</dd>
                                    <dd><code>readOnly</code> - whether the POIFileSystem will only be used in read-only
                                        mode
                                    </dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - on errors reading, or on invalid data</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="POIFSFileSystem-java.nio.channels.FileChannel-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>POIFSFileSystem</h4>
                                <pre>public&nbsp;POIFSFileSystem(java.nio.channels.FileChannel&nbsp;channel)
                throws java.io.IOException</pre>
                                <div class="block"><p>Creates a POIFSFileSystem from an open <tt>FileChannel</tt>. This
                                    uses
                                    less memory than creating from an <tt>InputStream</tt>. The stream will
                                    be used in read-only mode.</p>

                                    <p>Note that with this constructor, you will need to call <a
                                            href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#close--"><code>close()</code></a>
                                        when you're done to have the underlying Channel closed, as the channel is
                                        kept open during normal operation to read the data out.</p></div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>channel</code> - the FileChannel from which to read the data</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - on errors reading, or on invalid data</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="POIFSFileSystem-java.nio.channels.FileChannel-boolean-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>POIFSFileSystem</h4>
                                <pre>public&nbsp;POIFSFileSystem(java.nio.channels.FileChannel&nbsp;channel,
                       boolean&nbsp;readOnly)
                throws java.io.IOException</pre>
                                <div class="block"><p>Creates a POIFSFileSystem from an open <tt>FileChannel</tt>. This
                                    uses
                                    less memory than creating from an <tt>InputStream</tt>.</p>

                                    <p>Note that with this constructor, you will need to call <a
                                            href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#close--"><code>close()</code></a>
                                        when you're done to have the underlying Channel closed, as the channel is
                                        kept open during normal operation to read the data out.</p></div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>channel</code> - the FileChannel from which to read or read/write the data
                                    </dd>
                                    <dd><code>readOnly</code> - whether the POIFileSystem will only be used in read-only
                                        mode
                                    </dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - on errors reading, or on invalid data</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="POIFSFileSystem-java.io.InputStream-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>POIFSFileSystem</h4>
                                <pre>public&nbsp;POIFSFileSystem(java.io.InputStream&nbsp;stream)
                throws java.io.IOException</pre>
                                <div class="block">Create a POIFSFileSystem from an <tt>InputStream</tt>. Normally the
                                    stream is read until
                                    EOF. The stream is always closed.<p>

                                        Some streams are usable after reaching EOF (typically those that return <code>true</code>
                                        for <tt>markSupported()</tt>). In the unlikely case that the caller has such a
                                        stream
                                        <i>and</i> needs to use it after this constructor completes, a work around is to
                                        wrap the
                                        stream in order to trap the <tt>close()</tt> call. A convenience method (
                                        <tt>createNonClosingInputStream()</tt>) has been provided for this purpose:
                                    <pre>
 InputStream wrappedStream = POIFSFileSystem.createNonClosingInputStream(is);
 HSSFWorkbook wb = new HSSFWorkbook(wrappedStream);
 is.reset();
 doSomethingElse(is);
 </pre>
                                    Note also the special case of <tt>ByteArrayInputStream</tt> for which the <tt>close()</tt>
                                    method does nothing.
                                    <pre>
 ByteArrayInputStream bais = ...
 HSSFWorkbook wb = new HSSFWorkbook(bais); // calls bais.close() !
 bais.reset(); // no problem
 doSomethingElse(bais);
 </pre>
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>stream</code> - the InputStream from which to read the data</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - on errors reading, or on invalid data</dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="getBlockAt-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getBlockAt</h4>
                                <pre>protected&nbsp;java.nio.ByteBuffer&nbsp;getBlockAt(int&nbsp;offset)
                                  throws java.io.IOException</pre>
                                <div class="block">Load the block at the given offset.</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html#getBlockAt-int-">getBlockAt</a></code>&nbsp;in
                                        class&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html"
                                                title="class in org.apache.poi.poifs.filesystem">BlockStore</a></code>
                                    </dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="createBlockIfNeeded-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>createBlockIfNeeded</h4>
                                <pre>protected&nbsp;java.nio.ByteBuffer&nbsp;createBlockIfNeeded(int&nbsp;offset)
                                           throws java.io.IOException</pre>
                                <div class="block">Load the block at the given offset,
                                    extending the file if needed
                                </div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html#createBlockIfNeeded-int-">createBlockIfNeeded</a></code>&nbsp;in
                                        class&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html"
                                                title="class in org.apache.poi.poifs.filesystem">BlockStore</a></code>
                                    </dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getBATBlockAndIndex-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getBATBlockAndIndex</h4>
                                <pre>protected&nbsp;<a
                                        href="../../../../../org/apache/poi/poifs/storage/BATBlock.BATBlockAndIndex.html"
                                        title="class in org.apache.poi.poifs.storage">BATBlock.BATBlockAndIndex</a>&nbsp;getBATBlockAndIndex(int&nbsp;offset)</pre>
                                <div class="block">Returns the BATBlock that handles the specified offset,
                                    and the relative index within it
                                </div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html#getBATBlockAndIndex-int-">getBATBlockAndIndex</a></code>&nbsp;in
                                        class&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html"
                                                title="class in org.apache.poi.poifs.filesystem">BlockStore</a></code>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getNextBlock-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getNextBlock</h4>
                                <pre>protected&nbsp;int&nbsp;getNextBlock(int&nbsp;offset)</pre>
                                <div class="block">Works out what block follows the specified one.</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html#getNextBlock-int-">getNextBlock</a></code>&nbsp;in
                                        class&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html"
                                                title="class in org.apache.poi.poifs.filesystem">BlockStore</a></code>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setNextBlock-int-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setNextBlock</h4>
                                <pre>protected&nbsp;void&nbsp;setNextBlock(int&nbsp;offset,
                            int&nbsp;nextBlock)</pre>
                                <div class="block">Changes the record of what block follows the specified one.</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html#setNextBlock-int-int-">setNextBlock</a></code>&nbsp;in
                                        class&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html"
                                                title="class in org.apache.poi.poifs.filesystem">BlockStore</a></code>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getFreeBlock--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getFreeBlock</h4>
                                <pre>protected&nbsp;int&nbsp;getFreeBlock()
                    throws java.io.IOException</pre>
                                <div class="block">Finds a free block, and returns its offset.
                                    This method will extend the file if needed, and if doing
                                    so, allocate new FAT blocks to address the extra space.
                                </div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html#getFreeBlock--">getFreeBlock</a></code>&nbsp;in
                                        class&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html"
                                                title="class in org.apache.poi.poifs.filesystem">BlockStore</a></code>
                                    </dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="size--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>size</h4>
                                <pre>protected&nbsp;long&nbsp;size()
             throws java.io.IOException</pre>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getChainLoopDetector--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getChainLoopDetector</h4>
                                <pre>protected&nbsp;<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.ChainLoopDetector.html"
                                        title="class in org.apache.poi.poifs.filesystem">BlockStore.ChainLoopDetector</a>&nbsp;getChainLoopDetector()
                                                     throws java.io.IOException</pre>
                                <div class="block"><span
                                        class="descfrmTypeLabel">Description copied from class:&nbsp;<code><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html#getChainLoopDetector--">BlockStore</a></code></span>
                                </div>
                                <div class="block">Creates a Detector for loops in the chain</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html#getChainLoopDetector--">getChainLoopDetector</a></code>&nbsp;in
                                        class&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html"
                                                title="class in org.apache.poi.poifs.filesystem">BlockStore</a></code>
                                    </dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="createDocument-java.io.InputStream-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>createDocument</h4>
                                <pre>public&nbsp;<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DocumentEntry.html"
                                        title="interface in org.apache.poi.poifs.filesystem">DocumentEntry</a>&nbsp;createDocument(java.io.InputStream&nbsp;stream,
                                    java.lang.String&nbsp;name)
                             throws java.io.IOException</pre>
                                <div class="block">Create a new document to be added to the root directory</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>stream</code> - the InputStream from which the document's data
                                        will be obtained
                                    </dd>
                                    <dd><code>name</code> - the name of the new POIFSDocument</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the new DocumentEntry</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - on error creating the new POIFSDocument</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="createDocument-java.lang.String-int-org.apache.poi.poifs.filesystem.POIFSWriterListener-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>createDocument</h4>
                                <pre>public&nbsp;<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DocumentEntry.html"
                                        title="interface in org.apache.poi.poifs.filesystem">DocumentEntry</a>&nbsp;createDocument(java.lang.String&nbsp;name,
                                    int&nbsp;size,
                                    <a href="../../../../../org/apache/poi/poifs/filesystem/POIFSWriterListener.html"
                                       title="interface in org.apache.poi.poifs.filesystem">POIFSWriterListener</a>&nbsp;writer)
                             throws java.io.IOException</pre>
                                <div class="block">create a new DocumentEntry in the root entry; the data will be
                                    provided later
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>name</code> - the name of the new DocumentEntry</dd>
                                    <dd><code>size</code> - the size of the new DocumentEntry</dd>
                                    <dd><code>writer</code> - the writer of the new DocumentEntry</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the new DocumentEntry</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - if the writer exceeds the given size</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="createDirectory-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>createDirectory</h4>
                                <pre>public&nbsp;<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DirectoryEntry.html"
                                        title="interface in org.apache.poi.poifs.filesystem">DirectoryEntry</a>&nbsp;createDirectory(java.lang.String&nbsp;name)
                               throws java.io.IOException</pre>
                                <div class="block">create a new DirectoryEntry in the root directory</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>name</code> - the name of the new DirectoryEntry</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the new DirectoryEntry</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - on name duplication</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="createOrUpdateDocument-java.io.InputStream-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>createOrUpdateDocument</h4>
                                <pre>public&nbsp;<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DocumentEntry.html"
                                        title="interface in org.apache.poi.poifs.filesystem">DocumentEntry</a>&nbsp;createOrUpdateDocument(java.io.InputStream&nbsp;stream,
                                            java.lang.String&nbsp;name)
                                     throws java.io.IOException</pre>
                                <div class="block">Set the contents of a document in the root directory,
                                    creating if needed, otherwise updating
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>stream</code> - the InputStream from which the document's data
                                        will be obtained
                                    </dd>
                                    <dd><code>name</code> - the name of the new or existing POIFSDocument</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the new or updated DocumentEntry</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - on error populating the POIFSDocument</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="isInPlaceWriteable--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>isInPlaceWriteable</h4>
                                <pre>public&nbsp;boolean&nbsp;isInPlaceWriteable()</pre>
                                <div class="block">Does the filesystem support an in-place write via
                                    <a href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#writeFilesystem--"><code>writeFilesystem()</code></a>
                                    ? If false, only writing out to
                                    a brand new file via <a
                                            href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#writeFilesystem-java.io.OutputStream-"><code>writeFilesystem(OutputStream)</code></a>
                                    is supported.
                                </div>
                            </li>
                        </ul>
                        <a name="writeFilesystem--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>writeFilesystem</h4>
                                <pre>public&nbsp;void&nbsp;writeFilesystem()
                     throws java.io.IOException</pre>
                                <div class="block">Write the filesystem out to the open file. Will thrown an
                                    <code>IllegalArgumentException</code> if opened from an
                                    <code>InputStream</code>.
                                </div>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - thrown on errors writing to the stream</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="writeFilesystem-java.io.OutputStream-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>writeFilesystem</h4>
                                <pre>public&nbsp;void&nbsp;writeFilesystem(java.io.OutputStream&nbsp;stream)
                     throws java.io.IOException</pre>
                                <div class="block">Write the filesystem out</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>stream</code> - the OutputStream to which the filesystem will be
                                        written
                                    </dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - thrown on errors writing to the stream</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="close--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>close</h4>
                                <pre>public&nbsp;void&nbsp;close()
           throws java.io.IOException</pre>
                                <div class="block">Closes the FileSystem, freeing any underlying files, streams
                                    and buffers. After this, you will be unable to read or
                                    write from the FileSystem.
                                </div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code>close</code>&nbsp;in interface&nbsp;<code>java.io.Closeable</code></dd>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code>close</code>&nbsp;in interface&nbsp;<code>java.lang.AutoCloseable</code>
                                    </dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="main-java.lang.String:A-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>main</h4>
                                <pre>public static&nbsp;void&nbsp;main(java.lang.String[]&nbsp;args)
                 throws java.io.IOException</pre>
                                <div class="block">read in a file and write it back out again</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>args</code> - names of the files; arg[ 0 ] is the input file,
                                        arg[ 1 ] is the output file
                                    </dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getRoot--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getRoot</h4>
                                <pre>public&nbsp;<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DirectoryNode.html"
                                        title="class in org.apache.poi.poifs.filesystem">DirectoryNode</a>&nbsp;getRoot()</pre>
                                <div class="block">Get the root entry</div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the root entry</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="createDocumentInputStream-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>createDocumentInputStream</h4>
                                <pre>public&nbsp;<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DocumentInputStream.html"
                                        title="class in org.apache.poi.poifs.filesystem">DocumentInputStream</a>&nbsp;createDocumentInputStream(java.lang.String&nbsp;documentName)
                                              throws java.io.IOException</pre>
                                <div class="block">open a document in the root entry's list of entries</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>documentName</code> - the name of the document to be opened</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>a newly opened DocumentInputStream</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - if the document does not exist or the
                                        name is that of a DirectoryEntry
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getViewableArray--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getViewableArray</h4>
                                <pre>public&nbsp;java.lang.Object[]&nbsp;getViewableArray()</pre>
                                <div class="block">Get an array of objects, some of which may implement
                                    POIFSViewable
                                </div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html#getViewableArray--">getViewableArray</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html"
                                                title="interface in org.apache.poi.poifs.dev">POIFSViewable</a></code>
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>an array of Object; may not be null, but may be empty</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getViewableIterator--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getViewableIterator</h4>
                                <pre>public&nbsp;java.util.Iterator&lt;java.lang.Object&gt;&nbsp;getViewableIterator()</pre>
                                <div class="block">Get an Iterator of objects, some of which may implement
                                    POIFSViewable
                                </div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html#getViewableIterator--">getViewableIterator</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html"
                                                title="interface in org.apache.poi.poifs.dev">POIFSViewable</a></code>
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>an Iterator; may not be null, but may have an empty
                                        back end store
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="preferArray--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>preferArray</h4>
                                <pre>public&nbsp;boolean&nbsp;preferArray()</pre>
                                <div class="block">Give viewers a hint as to whether to call getViewableArray or
                                    getViewableIterator
                                </div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html#preferArray--">preferArray</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html"
                                                title="interface in org.apache.poi.poifs.dev">POIFSViewable</a></code>
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>true if a viewer should call getViewableArray, false if
                                        a viewer should call getViewableIterator
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getShortDescription--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getShortDescription</h4>
                                <pre>public&nbsp;java.lang.String&nbsp;getShortDescription()</pre>
                                <div class="block">Provides a short description of the object, to be used when a
                                    POIFSViewable object has not provided its contents.
                                </div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html#getShortDescription--">getShortDescription</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/dev/POIFSViewable.html"
                                                title="interface in org.apache.poi.poifs.dev">POIFSViewable</a></code>
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>short description</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getBigBlockSize--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getBigBlockSize</h4>
                                <pre>public&nbsp;int&nbsp;getBigBlockSize()</pre>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The Big Block size, normally 512 bytes, sometimes 4096 bytes</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getBigBlockSizeDetails--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getBigBlockSizeDetails</h4>
                                <pre>public&nbsp;<a
                                        href="../../../../../org/apache/poi/poifs/common/POIFSBigBlockSize.html"
                                        title="class in org.apache.poi.poifs.common">POIFSBigBlockSize</a>&nbsp;getBigBlockSizeDetails()</pre>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The Big Block size, normally 512 bytes, sometimes 4096 bytes</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="create-java.io.File-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>create</h4>
                                <pre>public static&nbsp;<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                        title="class in org.apache.poi.poifs.filesystem">POIFSFileSystem</a>&nbsp;create(java.io.File&nbsp;file)
                              throws java.io.IOException</pre>
                                <div class="block">Creates a new <a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                        title="class in org.apache.poi.poifs.filesystem"><code>POIFSFileSystem</code></a>
                                    in a new <code>File</code>.
                                    Use
                                    <a href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html#POIFSFileSystem-java.io.File-"><code>POIFSFileSystem(File)</code></a>
                                    to open an existing File,
                                    this should only be used to create a new empty filesystem.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>file</code> - The file to create and open</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The created and opened <a
                                            href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                            title="class in org.apache.poi.poifs.filesystem"><code>POIFSFileSystem</code></a>
                                    </dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getBlockStoreBlockSize--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getBlockStoreBlockSize</h4>
                                <pre>protected&nbsp;int&nbsp;getBlockStoreBlockSize()</pre>
                                <div class="block"><span
                                        class="descfrmTypeLabel">Description copied from class:&nbsp;<code><a
                                        href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html#getBlockStoreBlockSize--">BlockStore</a></code></span>
                                </div>
                                <div class="block">Returns the size of the blocks managed through the block store.</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html#getBlockStoreBlockSize--">getBlockStoreBlockSize</a></code>&nbsp;in
                                        class&nbsp;<code><a
                                                href="../../../../../org/apache/poi/poifs/filesystem/BlockStore.html"
                                                title="class in org.apache.poi.poifs.filesystem">BlockStore</a></code>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getPropertyTable--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getPropertyTable</h4>
                                <pre><a href="../../../../../org/apache/poi/util/Internal.html"
                                        title="annotation in org.apache.poi.util">@Internal</a>
public&nbsp;<a href="../../../../../org/apache/poi/poifs/property/PropertyTable.html"
               title="class in org.apache.poi.poifs.property">PropertyTable</a>&nbsp;getPropertyTable()</pre>
                            </li>
                        </ul>
                        <a name="getHeaderBlock--">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>getHeaderBlock</h4>
                                <pre><a href="../../../../../org/apache/poi/util/Internal.html"
                                        title="annotation in org.apache.poi.util">@Internal</a>
public&nbsp;<a href="../../../../../org/apache/poi/poifs/storage/HeaderBlock.html"
               title="class in org.apache.poi.poifs.storage">HeaderBlock</a>&nbsp;getHeaderBlock()</pre>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/POIFSFileSystem.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/poifs/filesystem/POIFSDocumentPath.html"
               title="class in org.apache.poi.poifs.filesystem"><span class="typeNameLink">Prev&nbsp;Class</span></a>
        </li>
        <li><a href="../../../../../org/apache/poi/poifs/filesystem/POIFSMiniStore.html"
               title="class in org.apache.poi.poifs.filesystem"><span class="typeNameLink">Next&nbsp;Class</span></a>
        </li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/poifs/filesystem/POIFSFileSystem.html" target="_top">Frames</a>
        </li>
        <li><a href="POIFSFileSystem.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li><a href="#nested.classes.inherited.from.class.org.apache.poi.poifs.filesystem.BlockStore">Nested</a>&nbsp;|&nbsp;
            </li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
